#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: check_deluser.pl,v 1.2 2002/02/14 23:22:42 pbaltz Exp $
# Copyright 2001 Sun Microsystems, Inc., All rights reserved.
# This handler checks preconditions for deleting a user.

use CCE;
use Base::HomeDir qw(homedir_create_user_link homedir_get_group_dir);

my $cce = new CCE;
$cce->connectfd();

# retreive user object data:
my $old = $cce->event_old();

# check for override flag
if ($old->{noFileCheck}) {
	$cce->bye('SUCCESS');
	exit(0);
}

my ($user_link, $link_target) = homedir_create_user_link($old->{name}, 
                                    $old->{site}, $old->{volume});
my $group_dir = homedir_get_group_dir($old->{site}, $old->{volume});

$link_target =~ s/^\.\.//;
$link_target = $group_dir . $link_target;

# If there are files outside of the user's home directory that the user
# owns, then don't allow the delete.  If they put a file in the site's
# web or ftp directory, there is a good chance that the admin will want
# to keep those files. This forces the admin to decide what to do instead
# of just erasing the files and hoping that was the desired action.
my $result = system("find $group_dir -user $old->{name} | grep -v $user_link | grep -v $link_target");

if ($result != 256) {
	$cce->warn("[[base-user.cleanupOldFiles]]");
	$cce->bye("FAIL");
	exit(0);
}

$cce->bye("SUCCESS");
exit(0);

