#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: deluser.pl,v 1.11 2002/02/08 00:24:11 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# 
# User._DESTROY handler
# author: Jonathan Mayer <jmayer@cobalt.com>

use Sauce::Config;
use Sauce::Util;
use CCE;
use Base::User qw(user_kill_processes userdel);
use Base::HomeDir qw(homedir_create_user_link);

my $cce = new CCE;
$cce->connectfd();

# retreive user object data:
my $oid = $cce->event_oid();

my $old = $cce->event_old();

# verify that we're really deleting a user
if (!$oid ) {
	$cce->warn('[[base-user.Invalid-object]]');
	$cce->bye("FAIL");
}

# verify that the user exists
my @user_info = getpwnam($old->{name});
if (!@user_info) {
	$cce->warn("[[base-user.Already-Destroyed,name=".$old->{name}."]]");
	# already destroyed?
	$cce->bye("SUCCESS");
    exit(0);
}

# clean the smbpasswd file
# FIXME

# clean the netatalk passwd file
# FIXME

# clean the htpasswd file
# FIXME

# clean the alias list and vacation stuff
# FIXME

# kill all of this user's currently running processes:
user_kill_processes($old->{name});

# get rid of friendly symlink
my ($user_link, $link_target) = homedir_create_user_link($old->{name}, 
                                    $old->{site}, $old->{volume});
unlink($user_link);
Sauce::Util::addrollbackcommand("umask 000; /bin/ln -sf \"$link_target\" \"$user_link\"");

# clean the password file
if (!(userdel(1, $old->{name}))[0])
{
    $cce->bye('FAIL', '[[base-user.cantDeleteUser]]');
    exit(1);
}

# update workgroups
update_workgroups();

sub update_workgroups
{
	my @oids = $cce->find("Workgroup", { 'members' => $old->{name} });
	foreach my $oid (@oids) {
		my ($ok, $obj) = $cce->get($oid);
		my (@members) = $cce->scalar_to_array($obj->{members});
		@members = grep {$_ ne $old->{name}} @members;
		$cce->set($oid, "", { 'members' =>
			$cce->array_to_scalar(@members) } );
	}
}

$cce->bye("SUCCESS");
exit 0;
